
#property copyright " 2008-2011 BJF Trading Group"
#property link      "www.iticsoftware.com"

#define vers   "1.0"

#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1  LightYellow
#property indicator_width1  1
#property indicator_style1  STYLE_SOLID


extern int  ROC_Period = 21;
extern int  ROC_Smoothing = 3;
extern bool ROC_UsePercent = false;

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

double ROCBuf[];

string short_name;

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

void init() 
{
  IndicatorBuffers(1);
    
  SetIndexStyle(0, DRAW_LINE);  
  SetIndexDrawBegin(0, ROC_Period+ROC_Smoothing);  
  SetIndexBuffer(0, ROCBuf);

  short_name = "RateOfChange(" + ROC_Period + ")";
  IndicatorShortName(short_name);
  
  SetIndexLabel(0, "ROC");
}

void deinit()
{
}

int start() 
{  
  int limit;
  double ROC, CurrentClose, PrevClose;
  int counted_bars = IndicatorCounted();
  //---- check for possible errors
  if(counted_bars < 0) 
     return(-1);
  //---- last counted bar will be recounted
  if(counted_bars > 0) 
     counted_bars--;
  limit = Bars - counted_bars - ROC_Period;
  
  for(int i=limit;i>=0;i--)
  {
    ROCBuf[i] = 0.0;
  }
  
  //---- ROC calculation
  for(i=0; i < limit; i++)
  {
    CurrentClose = iClose(NULL, 0, i);
    PrevClose = iClose(NULL, 0, i + ROC_Period);
    ROC = CurrentClose - PrevClose;
    //----
    if(ROC_UsePercent)
    {
      if(PrevClose != 0)
        ROCBuf[i] = 100 * ROC / PrevClose;
    }
    else
      ROCBuf[i] = ROC;
   } 
  //---- done
  
  if(ROC_Smoothing > 0)
  {
    for(i=limit;i>=0;i--)
    {
      ROCBuf[i] = iMAOnArray(ROCBuf,0,ROC_Smoothing,0,MODE_SMA,i);
    }
  }  
  
  return(0);
}

